openerp.clinic_history_medic = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.ClinicHistorymedicWidget = instance.Widget.extend({
        template : "clinic_history_medic.ClinicHistorymedic",
        jsonDoc:[],

        init:function(parent){
            this._super(parent);
        },

        updateId : function(id){
            var self = this;
            self.id=id;
        },

        start: function () {
            var self = this;
            this.$el.click(function (e) {
                self.fecthInitial();
            });
        },

        valorNull:function(dato){
            var valor ="";
            if (dato){
                if(dato == true && typeof dato == 'boolean'){
                    valor=" ";
                }else{
                    valor=dato;
                }
            }
            return valor;
        },

        fecthInitial: function(){
            var id= openerp.webclient._current_state.id;
            var self = this;
            self.fecthClinicMedicvisit(id).then(function(ClinicMedicvisit){
                return ClinicMedicvisit;
            }).then(function(ClinicMedicvisit){
                self.ClinicMedicvisit = ClinicMedicvisit;
                return self.fecthClinicMedicvisitLine();
            }).then(function(ClinicMedicvisitLine){
                self.ClinicMedicvisitLine = ClinicMedicvisitLine;
                return self.fecthClinicInsumosvisitLine();
            }).then(function(ClinicInsumosvisitLine){
                self.ClinicInsumosvisitLine = ClinicInsumosvisitLine;
                return self.drawPDF();
            });
            return false;
        },

        fecthClinicMedicvisit: function(id){
            var domain=[['id','=', id]];
            var ClinicMedicvisit = new instance.web.Model('clinic.history');
            return ClinicMedicvisit.call('getClinicMedicvisit',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        fecthClinicMedicvisitLine: function () {
            var self = this;
            var clinichistory_ids = _.flatten(_.map(self.ClinicMedicvisit,function(map){
                return map.id;
            }));
            var domain=[['clinichistory_id','in',clinichistory_ids]];
            var ClinicMedicvisitLine = new instance.web.Model('clinic.history.line');
            return ClinicMedicvisitLine.call('getClinicMedicvisitLine',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        fecthClinicInsumosvisitLine: function () {
            var self = this;
            var clinicinsumos_ids = _.flatten(_.map(self.ClinicMedicvisit,function(map){
                return map.id;
            }));
            var domain=[['clinichistory_id','in',clinicinsumos_ids]];
            var ClinicInsumosvisitLine = new instance.web.Model('clinic.insumos.line');
            return ClinicInsumosvisitLine.call('getClinicInsumosvisitLine',[domain], {
                context: new instance.web.CompoundContext()
            });
        },

        drawPDF:function(){
            var self = this;
            var doc = self.ClinicMedicvisit.shift();
            var docItem = [];
            var docWorkItem = [];
            var getColumns = [];
            var getColumns1 = [];
            var docWorkItem1 = [];
            var getColumnsMaterial1 = [];
            var aux1 = "";
            var aux2 = "";
            var aux3 = "";
            var aux4 = "";
            var aux5 = "";
            var aux6 = "";
            var aux7 = "";
            var aux8 = "";
            var antecedente_paciente = "";

            if(doc.ost  == true){
              aux1 =  "OST, "
            }
            if(doc.asm == true){
              aux2 = "ASM, "
            }
            if(doc.card  == true){
              aux3 =   "CARD, "
            }
            if(doc.acv == true){
              aux4 =   "ACV, "
            }
            if(doc.conv  == true){
              aux5 =   "CONV, "
            }
            if(doc.hta == true){
              aux6 =   "HTA, "
            }
            if(doc.epoc == true){
              aux7 =   "EPOC, "
            }
            if(doc.otro == true){
              aux8 =   "y otros, "
            }
            antecedente_paciente =  aux1 +"" + aux2 + "" +  aux3 + "" + aux4 + "" + aux5 + "" + aux6 + "" + aux7 + "" + aux8

            var pdfDoc = new jsPDF();
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.company_logo), 'PNG', 14, 3, 35, 20);

            /*
            =============================================================
                OBTENER LINEAS DEL PEDIDO
            =============================================================
            */
            var ClinicMedicvisitLine = self.ClinicMedicvisitLine;
            for (var i = 0; i < ClinicMedicvisitLine.length; i++) {
                docItem.push({
                    xnumber : i + 1,
                    product : ClinicMedicvisitLine[i].product_id[1],
                    brand : ClinicMedicvisitLine[i].brand,
                    number : ClinicMedicvisitLine[i].number
                })
            }

            getColumns.push({
                title : '',
                dataKey: 'xnumber',
                align: 'center',
            });

            getColumns.push({
                title : 'Servicios',
                dataKey: 'product',
                align: 'left',
            });
            getColumns.push({
                title : 'Cantidad',
                dataKey: 'brand',
                align: 'center',
            });
            getColumns.push({
                title : 'Estado',
                dataKey: 'number',
                align: 'center',
            });

            var ClinicInsumosvisitLine = self.ClinicInsumosvisitLine;
               for (var i = 0; i < ClinicInsumosvisitLine.length; i++) {
                   docWorkItem1.push({
                       xnumber : i + 1,
                       product: ClinicInsumosvisitLine[i].product_id[1],
                       quantity : ClinicInsumosvisitLine[i].quantity,
                       number : ClinicInsumosvisitLine[i].number
                   })
            }

            getColumnsMaterial1.push({
                title : 'N°',
                dataKey: 'xnumber',
                align: 'center',
            });
            getColumnsMaterial1.push({
                title : 'Insumos Utilizados',
                dataKey: 'product',
                align: 'left',
            });
            getColumnsMaterial1.push({
                title : 'Cantidad',
                dataKey: 'quantity',
                align: 'center',
            });
            getColumnsMaterial1.push({
                title : 'Estado',
                dataKey: 'number',
                align: 'center',
            });

            pdfDoc.autoTable(getColumns, docItem, {
                theme: 'grid',
                styles: {
                    overflow: 'linebreak',
                    columnWidth: 'auto',
                    fontSize: 7,

                },
                headerStyles: {
                    fillColor: [255, 255, 255],
                    borderColor: [150, 152, 154],
                    color: 'black',
                    fontStyle: 'bold',
                    textColor: [0, 0, 0],
                    fontSize: 8
                },
                columnStyles: {
                    xnumber : {halign:'center',columnWidth: '4px'},
                    product : {columnWidth: '8px',fontStyle: 'bold'},
                    brand : {halign:'center', columnWidth: '8px'},
                    number : {halign:'center',columnWidth: '8px'},
                },

                margin: { top: 139, horizontal: 14},


                addPageContent: function (data) {

                    /*
                    ====================================================================
                        CABECERA
                    ====================================================================
                    */



                    pdfDoc.setFontSize(14);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(105,10,'HISTORIA CLINICA PRE-HOSPITALAR');

                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(105,23, 'SERVICIO INTEGRAL DE SALUD S.A.');

                    pdfDoc.setFontSize(13);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(130,17,'Nº  ' +  doc.name);

                    pdfDoc.setDrawColor('252', '252', '252');
                    pdfDoc.rect(13, 25, pdfDoc.internal.pageSize.getWidth() - 18 , 29, 'S');
                    pdfDoc.rect(13, 25, pdfDoc.internal.pageSize.getWidth() - 18 , 63, 'S');
                    pdfDoc.rect(13, 25, pdfDoc.internal.pageSize.getWidth() - 18 , 115, 'S');

                    /*
                    ====================================================================
                        PRIMERA SECCION
                    ====================================================================
                    */

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(14,32,'Médico: ' + doc.user_name);


                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(71,32,'Paramédico: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(93,32, doc.paramedico_name);

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(140,32, 'Fecha: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(163,32, moment(doc.order_date).format('DD/MM/YYYY HH:mm'));

                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('normal');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(168,32, doc.partner_ruc);


                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('normal');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(32,60, );

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(14,37,'At. Base: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(31,37,self.valorNull(doc.at_base));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(50,37,'Móvil: ' );

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(65,37, self.valorNull(doc.name_movil));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(140,37,'Nº de Salida: ' );

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(168,37, self.valorNull(doc.nro_salida));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,42,'Fecha y Hora Recepción: ' );

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(58,42, moment(doc.planned_start_date).format('DD/MM/YYYY HH:mm'));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(89,42,self.valorNull(doc.programado));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(135,42,'Fecha y Hora Atención: ' );

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(176,42, moment(doc.planned_end_date).format('DD/MM/YYYY HH:mm'));

                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('bold');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(14,42,'Factura N°: ');
                    //

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(14,47,'Calle: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(29,47, doc.partner_address);

                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('bold');
                    // pdfDoc.setTextColor(10);
                    // pdfDoc.text(149,47,'Nº de Salida: ');
                    //
                    // pdfDoc.setFontSize(10);
                    // pdfDoc.setFontStyle('normal');
                    // pdfDoc.setTextColor(40);
                    // pdfDoc.text(156,47, self.valorNull(doc.nro_salida));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(14,52,'Tipo: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(29,52,self.valorNull(doc.tipo_paciente));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(75,52,'Lugar Visita: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(98,52, self.valorNull(doc.lugar_visita));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,57,'Uso alcohol en gel: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(49,57, self.valorNull(doc.uso_gel));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(75,57,'Antiguedad Trabajo: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(115,57, self.valorNull(doc.antig_trabajo));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(149,57,'Edad: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(160,57, self.valorNull(doc.edad_paciente));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,62,'Nombre y apellido: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(47,62, self.valorNull(doc.paciente_name));


                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(149,62,'Seguro: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(156,62, self.valorNull(doc.seguro));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,67,'Nº de Socio: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(47,67, self.valorNull(doc.nro_socio));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(75,67,'R.U.C: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(90,67, self.valorNull(doc.partner_ruc));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(149,67,'Sexo: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(160,67, self.valorNull(doc.partner_sexo));


                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,72,'Antecedentes:');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(41,72, self.valorNull(antecedente_paciente));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(80,72,'Alérgico: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(97,72, self.valorNull(doc.alergico));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(100,72, self.valorNull(doc.tipo_alergico));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(154,72,'Embarazada: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(177,72, self.valorNull(doc.embarazada));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,77,'Motivo de consulta: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(49,77, self.valorNull(doc.motivo));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(105,77,'Cel.:');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(109,77, self.valorNull(doc.mobile));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,82,'Signos Vitales: P.A.');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(48,82, self.valorNull(doc.pa));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(75,82,'F.C.');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(88,82, self.valorNull(doc.fc));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(105,82,'F.R.');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(122,77, self.valorNull(doc.fr));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(149,82,'Tº ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(156,82, self.valorNull(doc.temp));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,87,'SO');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(31,87, self.valorNull(doc.so));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(75,87,'HGT');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(90,87, self.valorNull(doc.hgt));

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,92,'Hallazgos Positivos del Examen Físico (o datos de importancia): ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(self.valorNull(doc.diagnostic), 14,97, {maxWidth:188,align:'justify'});

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,109,'Indicación Médica: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(self.valorNull(doc.indicacion), 14,112, {maxWidth:188,align:'justify'});

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,122,'Tratamiento Administrativo (medicamentos y dosis): ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(self.valorNull(doc.actions), 14, 127, {maxWidth:188,align:'justify'});

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(10);
                    pdfDoc.text(14,137,'Respuesta al Tratamiento: ');

                    pdfDoc.setFontSize(10);
                    pdfDoc.setFontStyle('normal');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(90,137, self.valorNull(doc.respuesta_tratamiento));
                }
            });

            /*
            =============================================================
                INSUMOS UTILIZADOS
            =============================================================
            */
            var finalY = pdfDoc.autoTable.previous.finalY;
            pdfDoc.autoTable(getColumnsMaterial1, docWorkItem1, {
                theme: 'grid',
                startY: finalY +3,
                styles: {
                    overflow: 'linebreak',
                    columnWidth: 'auto',
                    fontSize: 7,

                },
                headerStyles: {
                    fillColor: [255, 255, 255],
                    borderColor: [150, 152, 154],
                    fontSize: 8,
                    textColor: [0, 0, 0]
                },
                columnStyles: {
                    xnumber : {columnWidth: '8px', halign: 'center'},
                    product: {columnWidth: '8px', halign: 'left'},
                    quantity : {columnWidth: '8px', halign: 'center'},
                    number : {columnWidth: '4px', halign: 'center'},
                },
                margin: {horizontal: 14},
                // addPageContent: function (data) {
                //     pdfDoc.setFontSize(12);
                //     pdfDoc.setFontStyle('bold');
                //     pdfDoc.setTextColor(40);
                //     pdfDoc.text(15,finalY + 7,'CONTROL DE CALIDAD, FICHAS Y LACRES');
                // }
            });

            pdfDoc.rect(13, pdfDoc.autoTable.previous.finalY + 1, pdfDoc.internal.pageSize.getWidth() - 18 , 64, 'S');
            pdfDoc.rect(13, pdfDoc.autoTable.previous.finalY + 1, pdfDoc.internal.pageSize.getWidth() - 18 , 72, 'S');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(10);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 5,'Recomendaciones: ');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(self.valorNull(doc.recommendations), 14,pdfDoc.autoTable.previous.finalY + 10, {maxWidth:188,align:'justify'});

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(10);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 20,'Epicrisis:');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(30,pdfDoc.autoTable.previous.finalY + 20, self.valorNull(doc.epicrisis));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(80,pdfDoc.autoTable.previous.finalY + 20,'Clasificación de la Atención: ');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(125,pdfDoc.autoTable.previous.finalY + 20, self.valorNull(doc.clasificacion));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(10);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 25,'Diagnóstico Presuntivo:');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 30, self.valorNull(doc.presuntivo));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 40,'Firma y Sello Profesional SIS');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(110,pdfDoc.autoTable.previous.finalY + 40,'Firma Paciente o Responsable');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 45,'Paramédico');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.signature_image_paramedico), 'PNG', 40, pdfDoc.autoTable.previous.finalY + 38, 18, 15);


            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
          //  pdfDoc.text(65,pdfDoc.autoTable.previous.finalY + 60, self.valorNull(doc.user_image));
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.paramedico_image), 'PNG', 65, pdfDoc.autoTable.previous.finalY + 30, 25, 15);




            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(110,pdfDoc.autoTable.previous.finalY + 45,'C.I.Nª:');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(120,pdfDoc.autoTable.previous.finalY + 45, self.valorNull(doc.presuntivo));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
          //  var imgData = 'data:image/jpeg;base64,'+ Base64.encode('doc.signature_image_paciente');
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.signature_image_paciente), 'PNG', 160, pdfDoc.autoTable.previous.finalY + 35, 18, 15);
            //pdfDoc.text(170,pdfDoc.autoTable.previous.finalY + 50, self.valorNull(imgData));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 55,'Médico');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.signature_image_medico), 'PNG', 55, pdfDoc.autoTable.previous.finalY + 50, 18, 15);
          //  pdfDoc.text(30,pdfDoc.autoTable.previous.finalY + 60, self.valorNull(doc.signature_image_medico));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
          //  pdfDoc.text(65,pdfDoc.autoTable.previous.finalY + 60, self.valorNull(doc.user_image));
            pdfDoc.addImage("data:image/png;base64," + self.valorNull(doc.user_image), 'PNG', 75, pdfDoc.autoTable.previous.finalY + 45, 25, 15);

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(14,pdfDoc.autoTable.previous.finalY + 60,'Informado a: ');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(37,pdfDoc.autoTable.previous.finalY + 60, self.valorNull(doc.informado));

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(110,pdfDoc.autoTable.previous.finalY + 60,'Entrega a: ');

            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('normal');
            pdfDoc.setTextColor(40);
            pdfDoc.text(129,pdfDoc.autoTable.previous.finalY + 60, self.valorNull(doc.entregado));


            pdfDoc.setFontSize(10);
            pdfDoc.setFontStyle('bold');
            pdfDoc.setTextColor(40);
            pdfDoc.text(70,pdfDoc.autoTable.previous.finalY + 70,'"EXCELENCIA EN SERVICIOS DE SALUD"');

            pdfDoc.save('HISTORIA CLINICA PRE-HOSPITALAR.pdf');
        },
    });
    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_form: function (record) {
                this._super.apply(this, arguments);
                if (this.model !== 'clinic.history') return;
                local.parentInstance = this;
                if (local.widgetInstance) {
                    local.widgetInstance.updateId(record.id);
                }
                local.widgetInstance = new local.ClinicHistorymedicWidget(this);
                var elemento = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
                elemento =  elemento.find('.oe_right.oe_button_box.clinichistorymedic_button_box');
                local.widgetInstance.appendTo(elemento);
                local.widgetInstance.updateId(record.id);
            }
        });
    }
};
